commit 7236c7e29cef1c2d76c7a284c5081ff4d3aa1127
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sun Dec 27 01:59:00 2020 +0200

    2.7.4

 NEWS             | 7 +++++++
 configure.ac     | 2 +-
 meson.build      | 2 +-
 src/hb-version.h | 4 ++--
 4 files changed, 11 insertions(+), 4 deletions(-)

commit 6808b1fb3075990c389e3a2e80cee8c4874a8f6f
Merge: 010bd540 e8c15b7a
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sun Dec 27 01:55:15 2020 +0200

    Merge pull request #2781 from harfbuzz/g-i-dist
    
    [ci] Install gobject-introspection on distcheck job

commit e8c15b7a1cd2c2174658e221193bb83d1ca4c635
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sat Dec 26 23:05:48 2020 +0200

    [ci] Install gobject-introspection on distcheck job
    
    To fix missing --enable-introspection from release tarballs.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2779

 .circleci/config.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 010bd5404008e45bb23ff63613551a03e3b60f58
Merge: 462b71ea fdf3e448
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sat Dec 26 01:17:27 2020 +0200

    Merge pull request #2777 from harfbuzz/docs-unicode
    
    [docs] Improve hb-unicode docs a bit

commit 462b71eaf3aff628cc50554f2ebcb78e27262e39
Merge: 95416714 22468c8a
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sat Dec 26 01:16:32 2020 +0200

    Merge pull request #1676 from n8willis/docs-gtkdoc-core
    
    [Docs] Add gtkdoc comments for low-level core APIs

commit 22468c8a9046d03751039ae82626c780c74fdc66
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 22:38:06 2020 +0200

    [docs] Give destroy callbacks have (optional) annotation

 src/hb-blob.cc       |  4 ++--
 src/hb-font.h        | 30 +++++++++++++++---------------
 src/hb-ft.cc         |  2 +-
 src/hb-map.cc        |  2 +-
 src/hb-set.cc        |  2 +-
 src/hb-shape-plan.cc |  2 +-
 src/hb-unicode.cc    |  2 +-
 src/hb-unicode.h     | 12 ++++++------
 8 files changed, 28 insertions(+), 28 deletions(-)

commit 35c4a15a676beb6d9198e2a9b7f06ac5ab669b2c
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 22:34:02 2020 +0200

    [docs] Update hb-font documentation

 src/hb-font.cc | 20 +++++++++++---------
 1 file changed, 11 insertions(+), 9 deletions(-)

commit 8586f15957ac593aad786ad839b49596e45c0fa8
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 22:23:47 2020 +0200

    [docs] Update hb-common documentation

 src/hb-common.cc |  5 +++--
 src/hb-common.h  | 16 +++++++---------
 2 files changed, 10 insertions(+), 11 deletions(-)

commit e8c21e003dfe84a2b8c8801821176575bfa7bbb4
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 21:56:31 2020 +0200

    [docs] Remove comments the duplicate docs

 src/hb-font.h | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit ff96f73f8f62344fc9d0c557bcc79cd6c2d0b95f
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 21:53:11 2020 +0200

    [docs] Add some missing API to harfbuzz-sections.txt

 docs/harfbuzz-sections.txt | 2 ++
 1 file changed, 2 insertions(+)

commit cb319f0d80ab76da00c7263a7e0a433558fa73a2
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 21:47:05 2020 +0200

    [docs] Add some missing annotations to hb-buffer.cc

 src/hb-buffer.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9af0edd9511cdba61ad3bd2ce23eb789e9eb58fe
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 21:40:41 2020 +0200

    [docs] Document return value of hb_blob_get_data()

 src/hb-blob.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f88e845fc789cb1af3956b53b749987af8d6adc8
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 21:28:37 2020 +0200

    [docs] Minor fixes

 src/hb-blob.cc    | 6 +++---
 src/hb-buffer.cc  | 4 ++--
 src/hb-face.cc    | 2 +-
 src/hb-font.cc    | 2 +-
 src/hb-map.cc     | 2 +-
 src/hb-set.cc     | 2 +-
 src/hb-unicode.cc | 2 +-
 7 files changed, 10 insertions(+), 10 deletions(-)

commit 82092d4005aa1ce38e069b43d35282089af4ea79
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Mon Apr 22 15:31:24 2019 +0100

    [docs] Update gtk-doc comments in hb-font

 src/hb-font.cc | 623 +++++++++++++++++++++++++++++++++++----------------------
 src/hb-font.h  | 371 ++++++++++++++++++++++++++--------
 2 files changed, 679 insertions(+), 315 deletions(-)

commit e8de26e1ef7b4486ff7b13aadb89c06300f1b705
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Sun Apr 21 20:31:54 2019 +0100

    [docs] Add gtkdoc comments to hb-buffer

 src/hb-buffer.cc | 235 +++++++++++++++++++++++++++++--------------------------
 src/hb-buffer.h  |  17 ++++
 2 files changed, 139 insertions(+), 113 deletions(-)

commit d13b7eaaf18e772387ce25e899e2b3d4252c9e96
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Sun Apr 21 20:31:31 2019 +0100

    [docs] Add gtkdoc comments to hb-blob

 src/hb-blob.cc | 48 +++++++++++++++++++++++++++---------------------
 src/hb-blob.h  | 35 ++++++++++++++++++++++++++---------
 2 files changed, 53 insertions(+), 30 deletions(-)

commit 4cdb12a3fa804392ec93e29633235f9552a4e106
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Sun Apr 21 20:31:09 2019 +0100

    [docs] Add gtkdoc comments to hb-common

 src/hb-common.cc |  82 +++++++++-------
 src/hb-common.h  | 295 +++++++++++++++++++++++++++++++++++++++++++++++++++++--
 2 files changed, 337 insertions(+), 40 deletions(-)

commit 922c32eb2df9bfedc15420ceef99f35c6be07e12
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Sun Apr 21 20:30:54 2019 +0100

    [docs] Add gtkdoc comments to hb-map

 src/hb-map.cc | 87 ++++++++++++++++++++++++++++++++++++-----------------------
 src/hb-map.h  |  6 +++++
 2 files changed, 60 insertions(+), 33 deletions(-)

commit 71af2c6d9b58213963577a01c97dc9dc021dc6b7
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Sun Apr 21 20:30:36 2019 +0100

    [docs] Add gtkdoc comments to hb-set

 src/hb-set.cc | 207 ++++++++++++++++++++++++++++++++--------------------------
 src/hb-set.h  |   9 +++
 2 files changed, 124 insertions(+), 92 deletions(-)

commit ec98730ff69a744955c5d98aa38078eb0bb8fd24
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Wed Apr 17 14:44:25 2019 +0100

    [docs] regularize whitespace in function params

 src/hb-font.cc | 563 ++++++++++++++++++++++++++++++---------------------------
 1 file changed, 295 insertions(+), 268 deletions(-)

commit fdf3e448fdf92385675e64563b0489d8aea2e1b8
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 00:41:45 2020 +0200

    [docs] Improve hb-unicode docs a bit
    
    Down to only one warning.

 src/hb-unicode.h | 80 ++++++++++++++++++++++++++++++++++++++++----------------
 1 file changed, 58 insertions(+), 22 deletions(-)

commit 0fd6144a5fd0de86c509e35a552105faca458fb2
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Dec 24 00:10:27 2020 +0200

    [docs] Fix warnings about unknown annotations
    
    Use square brackets so that gtk-doc does not consider these to be
    annotations.

 src/hb-unicode.h | 168 +++++++++++++++++++++++++++----------------------------
 1 file changed, 84 insertions(+), 84 deletions(-)

commit 954167143befde8366150dcb885f50a9e64346a3
Merge: 8560c3e3 71a3b54f
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Wed Dec 23 23:04:17 2020 +0200

    Merge pull request #2776 from harfbuzz/release
    
    2.7.3

commit 71a3b54f3c6c6fba52a2f99e6a9258c62b5104cd
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 15:33:15 2020 +0200

    2.7.3

 NEWS             | 23 +++++++++++++++++++++++
 configure.ac     |  2 +-
 meson.build      |  2 +-
 src/hb-buffer.cc |  2 +-
 src/hb-version.h |  4 ++--
 5 files changed, 28 insertions(+), 5 deletions(-)

commit 8560c3e355dbfd199fbd9e7052151c40a9039b29
Merge: 769a21aa 296e9d7f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 23 00:25:10 2020 -0800

    Merge pull request #2774 from harfbuzz/misc-doc
    
    Doc fixes

commit 769a21aab6a2b1c43cc10d56de3861a3add723de
Author: Ryan <ryan@luciaonline.net>
Date:   Wed Dec 23 02:31:03 2020 -0500

    meson: avoid regenerating hb-version.h unnecessarily
    
    The file is a dependency for the library as a whole, so previously editing the Meson build files at all would force a full rebuild. This will only rebuild it if the version has changed.

 src/gen-hb-version.py | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit 296e9d7f33fb314d0bd4e0dad5a85f60aefdade9
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 01:18:10 2020 +0200

    [ci] Install fonttools using pip on msys2
    
    Hopefully fixes the broken package.

 .github/workflows/msys2-ci.yml | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 3dba7ea93638df814b93d75d31ad3da24605704d
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 00:55:21 2020 +0200

    [docs] Add missing API index for 1.4.0 release

 docs/harfbuzz-docs.xml | 1 +
 1 file changed, 1 insertion(+)

commit c2e2c40bacb296526e1b395a957af0e13da4486f
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 00:49:23 2020 +0200

    [docs] Fix gtk-doc comment syntax
    
    The documentation was not picked otherwise.

 src/hb-aat-layout.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 0826940821e9b8068b0341dae4d3ea237df86aa2
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 00:45:39 2020 +0200

    [docs] Add messing sections
    
    Docs for these sections were not generated at all.

 docs/harfbuzz-docs.xml |  4 ++++
 src/hb-directwrite.cc  |  9 +++++++++
 src/hb-gdi.cc          | 10 ++++++++++
 src/hb-ot-metrics.cc   |  9 +++++++++
 4 files changed, 32 insertions(+)

commit b8b13018edc4115e9857d7871d254c5737f90046
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Dec 23 00:22:56 2020 +0200

    [docs] Make gtk-doc find these typedef’s

 src/hb-aat-layout.h    | 3 +--
 src/hb-buffer.h        | 3 +--
 src/hb-font.h          | 6 ++----
 src/hb-ot-color.h      | 3 +--
 src/hb-ot-deprecated.h | 3 +--
 src/hb-ot-name.h       | 3 +--
 src/hb-ot-var.h        | 3 +--
 7 files changed, 8 insertions(+), 16 deletions(-)

commit 8c3a530fd7aa832215b84f4f38d58f58ac8a5832
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Tue Dec 22 23:52:46 2020 +0200

    [docs] Some formatting fixes

 src/hb-buffer-serialize.cc | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit b029a45caa6067c752643e49b30233a74a8be721
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Tue Dec 22 23:32:48 2020 +0200

    [docs] Add new API to harfbuzz-sections.txt

 docs/harfbuzz-docs.xml     | 1 +
 docs/harfbuzz-sections.txt | 3 +++
 2 files changed, 4 insertions(+)

commit ea4476d7389b8b5d30f1d969787c752856c32088
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Mon Dec 21 17:44:03 2020 +0200

    [autotools] Don’t fallback to icu-config
    
    ICU pkg-config support have been available for a long time, and
    icu-config often breaks cross-compiling when the one from host system is
    found.

 configure.ac | 19 -------------------
 1 file changed, 19 deletions(-)

commit 2953a66ab685957f57e52fb45f42445030d41e06
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:   Wed Dec 9 12:24:18 2020 +0800

    CMake: Define HAVE_GOBJECT when harfbuzz-gobject is built
    
    Without this, the built library for harfbuzz-gobject is unuseful.

 CMakeLists.txt | 1 +
 1 file changed, 1 insertion(+)

commit 25c0a792e3c2642e3796e0428fb315da9dc2618e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 10 14:29:47 2020 -0700

    Remove unused+wrong UnsizedArrayOf<> operators
    
    Said compiler is wrong to err since they are unused. But yeah, they
    didn't make sense and were copy/paste leftover.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2763

 src/hb-open-type.hh | 2 --
 1 file changed, 2 deletions(-)

commit 07e304b2a488261a89e74f396902399cb28f5608
Merge: 7c241651 5f32fdff
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Tue Dec 1 22:32:19 2020 +0200

    Merge pull request #2755 from Myaamori/master
    
    meson: use meson.current_source_dir() instead of @CURRENT_SOURCE_DIR@

commit 7c241651ac3c8a4d97a0a04d4db5bd0088988ed9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Nov 30 16:38:53 2020 -0700

    [algs] Don't forward rvalue twice
    
    Part of https://github.com/harfbuzz/harfbuzz/issues/2293

 src/hb-algs.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 53806e5b83cee0e275eac038d0780f95ac56588c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 25 11:51:37 2020 -0700

    Tiny improvement on previous commit
    
    Functionally the same.

 src/hb-blob.hh               | 1 +
 src/hb-null.hh               | 1 +
 src/hb-ot-layout-gsubgpos.hh | 2 +-
 3 files changed, 3 insertions(+), 1 deletion(-)

commit a5f6f869e80c371665026dfe9d156f0088f2553d
Author: Dominik Röttsches <drott@chromium.org>
Date:   Fri Oct 23 14:25:05 2020 +0300

    Drop layout table if layout lookup accelerator allocation failed
    
    If the table is kept, when the table is present but only the accelerator
    allocation failed, then we run into nullptr dereferences downstream in
    hb_ot_map_t::apply when trying to access proxy.accels[i].
    
    To fix this, instead of only setting lookup_count of accelerator_t
    itself, drop the whole table to avoid hb-ot-map construction assuming
    that the lookups will work correctly despite accelerator allocation
    having failed.
    
    Fixes:
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=24490
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=24490

 src/hb-ot-layout-gsubgpos.hh | 4 ++++
 1 file changed, 4 insertions(+)

commit 5f32fdff11bca45ca842dea583f1afd51a6435b9
Author: Myaamori <myaamori1993@gmail.com>
Date:   Tue Nov 24 01:29:24 2020 +0000

    meson: use meson.current_source_dir() instead of @CURRENT_SOURCE_DIR@
    
    @CURRENT_SOURCE_DIR@ is not listed as a valid string substitution
    for custom targets in the Meson reference, and in practice
    it does not get substituted when using the vs2019 backend.

 src/meson.build | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b2e7bb2a7caa20af244b7452ec960f9957eb8bba
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Tue Oct 27 19:50:33 2020 -0400

    Don’t map BCP 47 to coincidentally similar OT tag

 src/gen-tag-table.py   |  34 ++++++++---
 src/hb-ot-tag-table.hh | 163 +++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-tag.cc       |   1 +
 test/api/test-ot-tag.c |   4 ++
 4 files changed, 194 insertions(+), 8 deletions(-)

commit e1df2c5277a365d5e0c83d811f0b95f66428430b
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Mon Oct 26 19:16:35 2020 -0400

    Map ISO 639 code qul to language system tag 'QUH '

 src/gen-tag-table.py   | 1 +
 src/hb-ot-tag-table.hh | 1 +
 2 files changed, 2 insertions(+)

commit bac8a856f8ce034fde04f024065455c8b29bba5e
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sat Nov 21 16:07:57 2020 +0200

    Revert "[CI] Don’t install ragel on circleci jobs"
    
    This reverts commit 9a9da110a54ea03a0bdd1e64fa9ff7a2b98ba53c.

 .circleci/config.yml | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit f579c66108d4b9d122213704078c998bc194d427
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sat Nov 21 16:06:27 2020 +0200

    Mark variable unused
    
    Hopefully fixes build with newer ragel.
    
    https://github.com/adrian-thurston/ragel/issues/56
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2752

 src/hb-ot-shape-complex-use-machine.hh | 2 +-
 src/hb-ot-shape-complex-use-machine.rl | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit f83496a9101f764e4eaec2ce205d55aa4f78558f
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Fri Nov 20 08:16:36 2020 -0500

    [use] Remove workaround for reserved code points
    
    See <https://github.com/microsoft/font-tools/issues/12>.

 src/gen-use-table.py                            | 4 +---
 src/ms-use/IndicSyllabicCategory-Additional.txt | 5 ++++-
 2 files changed, 5 insertions(+), 4 deletions(-)

commit 17da41bd06f2b993976379c8ab9287b485f58dee
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Tue Nov 17 14:29:05 2020 -0500

    Update language system tag registry to OT 1.8.4

 src/gen-tag-table.py   |   7 +-
 src/hb-ot-tag-table.hh | 909 +++++++++++++++++++++++++++++++++++++------------
 test/api/test-ot-tag.c |   6 +-
 3 files changed, 704 insertions(+), 218 deletions(-)

commit 385d9c08d8906002690a7fbff86c1592f5b627b9
Merge: c4ade4fd 9722b4b2
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Tue Nov 17 19:43:22 2020 +0200

    Merge pull request #2700 from xclaesse/cairo-ft
    
    meson: Fix cairo_ft_dep when fontconfig is a subproject

commit 9722b4b269bda2d7e84c3164d69caa1324f8f8b3
Author: Xavier Claessens <xavier.claessens@collabora.com>
Date:   Tue Nov 17 11:56:52 2020 -0500

    Meson: Update all wrap files to latest version

 subprojects/expat.wrap            | 19 +++++++++----------
 subprojects/fontconfig.wrap       |  6 +++---
 subprojects/google-benchmark.wrap | 15 ++++++++-------
 subprojects/libpng.wrap           | 22 ++++++++++++----------
 subprojects/zlib.wrap             | 17 ++++++++++++-----
 5 files changed, 44 insertions(+), 35 deletions(-)

commit a082fe400d1c981e22061168299334c853ad85a6
Author: Xavier Claessens <xavier.claessens@collabora.com>
Date:   Fri Nov 6 13:02:21 2020 -0500

    ci: Install meson 0.56.0 in crossbuild-win32
    
    It is required for using cairo as subproject.

 .circleci/config.yml | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit e2ba0e009e499e82b2922db7e58e91bc5f452d03
Author: Xavier Claessens <xavier.claessens@collabora.com>
Date:   Sat Oct 3 21:34:24 2020 -0400

    meson: Fix check for cairo and cairo-ft dependencies
    
    When cairo comes from a subproject fallback it should still take
    cairo-ft dependency, otherwise it miss freetype2 cflags.
    
    Also update wrap file to use upstream repository now that meson support
    has been merged.
    
    This requires Meson >= 0.54.0 because cairo itself requires that version
    and we use the new `fallback: 'cairo'` syntax without specifying a
    variable name because cairo does not provide a variable name for
    cairo-ft.

 meson.build            | 37 +++++++++++++++++--------------------
 subprojects/cairo.wrap |  4 ++--
 2 files changed, 19 insertions(+), 22 deletions(-)

commit c4ade4fdd681b59c0694b7422d7a123fd1e9e6b8
Merge: e6c21d7b fd8f4ffc
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Tue Nov 17 14:32:04 2020 +0200

    Merge pull request #2686 from simoncozens/more-tracing
    
    More tracing

commit fd8f4ffcc6851ff9024957779be50411e87724d5
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Fri Sep 18 16:37:22 2020 +0100

    Trace reorder, not normalize

 src/hb-ot-shape-normalize.cc | 3 ++-
 src/hb-ot-shape.cc           | 5 +----
 2 files changed, 3 insertions(+), 5 deletions(-)

commit 2e0193d7417d1134e1710bf3fa7690332bc561e0
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Fri Sep 18 16:28:29 2020 +0100

    Add more cast spaces

 src/hb-ot-shape.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 4bb6d54e3bd16ae42364587f9703128b95de89de
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Fri Sep 18 16:26:08 2020 +0100

    Missing cast

 src/hb-ot-shape-complex-indic.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8e1bedc50b13d19e1fb3c0fbb0cfa6d87f042f51
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Fri Sep 18 16:25:43 2020 +0100

    Keep phase names

 src/hb-ot-shape.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 428c111f1389e3ebf8b694f342ffdc011f2ee043
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Fri Sep 18 16:24:47 2020 +0100

    Fix spacing around casts

 src/hb-ot-layout.cc                | 4 ++--
 src/hb-ot-shape-complex-indic.cc   | 2 +-
 src/hb-ot-shape-complex-khmer.cc   | 2 +-
 src/hb-ot-shape-complex-myanmar.cc | 2 +-
 src/hb-ot-shape-complex-use.cc     | 2 +-
 5 files changed, 6 insertions(+), 6 deletions(-)

commit f19018da412cf0949748dc8ba80e1a0a376238af
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Thu Sep 17 15:08:32 2020 +0100

    Smaller issues from review

 src/hb-ot-shape-complex-indic.cc   | 12 ++++++------
 src/hb-ot-shape-complex-myanmar.cc |  2 +-
 src/hb-ot-shape.cc                 |  6 +++---
 3 files changed, 10 insertions(+), 10 deletions(-)

commit 8b3b835a0aaf7b21825ad87f0e0ab9efbff34dcc
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Thu Sep 17 14:27:31 2020 +0100

    Trace normalization and preprocessing stages

 src/hb-ot-shape.cc | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit b50099bff22f9add10e100b6ace5a063a574a066
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Thu Sep 17 14:25:30 2020 +0100

    Trace reordering in pause functions

 src/hb-ot-shape-complex-indic.cc   | 10 ++++++++--
 src/hb-ot-shape-complex-khmer.cc   | 10 ++++++----
 src/hb-ot-shape-complex-myanmar.cc |  9 ++++++---
 src/hb-ot-shape-complex-use.cc     | 10 +++++++---
 4 files changed, 27 insertions(+), 12 deletions(-)

commit e6c21d7b58224f483395a6c9355fe89d88aedd54
Merge: 3bd43bd0 0c3dcfae
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Tue Nov 17 08:53:32 2020 +0200

    Merge pull request #2692 from ffontaine/master
    
    src/meson.build: allow introspection when cross-compiling

commit 0c3dcfae193efd8d5333c44075ba01932edc1059
Merge: 2604201a 3bd43bd0
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Tue Nov 17 07:31:07 2020 +0100

    Merge remote-tracking branch 'upstream/master'

commit 3bd43bd023ab713781058f9ce5bcb7566ecb2d68
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Mon Nov 16 21:55:02 2020 -0500

    Map more ISO 15924 variants to `hb_script_t`s

 src/hb-common.cc | 5 +++++
 1 file changed, 5 insertions(+)

commit 27170e058d2925ea05bf59f1ee8f56fb0bcb576a
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Wed Oct 28 18:02:55 2020 -0400

    Fix names for language tag in gen-tag-table.py
    
    A BCP 47 language tag with both a script subtag and a region subtag
    would be printed as a human-readable name in hb-ot-tag-table.hh as if it
    only had its language subtag.

 src/gen-tag-table.py   |  18 +++----
 src/hb-ot-tag-table.hh | 126 ++++++++++++++++++++++++-------------------------
 2 files changed, 73 insertions(+), 71 deletions(-)

commit 5091ea7e247b118009c719076650a93b3e2dde6d
Merge: 69cc214c 07961dae
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Sat Oct 24 22:37:52 2020 +0200

    Merge pull request #2733 from astiob/buffer-context-doc
    
    [docs] Describe buffer context applicability more explicitly

commit 07961daed06d181615d8087b25122985c83760cc
Author: Oleg Oshmyan <chortos@inbox.lv>
Date:   Sat Oct 24 21:58:02 2020 +0300

    [docs] Describe buffer context applicability more explicitly
    
    Make it abundantly clear that the context's script etc. don't matter.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2730

 docs/usermanual-buffers-language-script-and-direction.xml | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 69cc214c9a47ec9f19bfe477149c6c68cff6a483
Merge: 49ebb9eb 5adc1344
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Sat Oct 24 10:41:33 2020 +0200

    Merge pull request #2729 from khaledhosny/autotools-pkg-config
    
    [autotools] Require pkg-config 0.28

commit 5adc1344a4c695ed655aabd02c8bfab114bb4d52
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Fri Oct 23 18:39:34 2020 +0200

    [ci] Upload meason logs on some CircleCI jobs

 .circleci/config.yml | 6 ++++++
 1 file changed, 6 insertions(+)

commit 71376f88ef07163f1330f1f54f9f479cd3a67306
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Fri Oct 23 18:21:41 2020 +0200

    [ci] CircleCI removed xcode:9.0.1 image
    
    The replacement run newer versions of macOS (10.13.3), making this job
    obsolete as it tests nothing the other jobs don’t test.

 .circleci/config.yml | 12 ------------
 1 file changed, 12 deletions(-)

commit 05403a07b5accbc248064ec44fb884efeb811fa2
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Fri Oct 23 17:24:29 2020 +0200

    [autotools] Require pkg-config 0.28
    
    Follow up 0615c7b64b63400b2a70a1a6dd8a57d0b0fff10c, which fixes #1565.
    This seems to be the version that fixed the circular dependency, based
    on the ChangeLog:
    https://cgit.freedesktop.org/pkg-config/commit/?h=pkg-config-0.28&id=74ceac54ef6f9247c00f08eecd8cca811a3c5934

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 49ebb9ebdd689490c74da835a3fb829f14df6ed1
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 17 12:03:44 2020 -0400

    [use] Remove redundant O entries from the table

 src/gen-use-table.py                 | 11 +++---
 src/hb-ot-shape-complex-use-table.cc | 69 ++++++++++++++++++------------------
 2 files changed, 39 insertions(+), 41 deletions(-)

commit 79fd5ce22e03d9db6553dadc0a5e3862b0bfa20d
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 17 11:57:08 2020 -0400

    [use] Merge IND and Rsv classes into O

 src/gen-use-table.py                   | 10 ++-------
 src/hb-ot-shape-complex-use-machine.hh | 40 +++++++++++++++++-----------------
 src/hb-ot-shape-complex-use-machine.rl |  6 ++---
 src/hb-ot-shape-complex-use-table.cc   | 20 +++++++----------
 src/hb-ot-shape-complex-use.hh         |  2 --
 5 files changed, 32 insertions(+), 46 deletions(-)

commit c2cdcd4901132ea7690bda655602d84e63505eb1
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sat Oct 17 21:57:27 2020 +0200

    [tests] warning: unused variable 'num_glyphs'

 test/api/test-buffer.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e25aa49a1bcd8f25eeda1846c7daf9b887571d84
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 17 12:32:41 2020 -0400

    Fix a dead link in CMakeLists.txt

 CMakeLists.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9a9da110a54ea03a0bdd1e64fa9ff7a2b98ba53c
Author: Khaled Hosny <dr.khaled.hosny@gmail.com>
Date:   Sat Oct 17 17:58:11 2020 +0200

    [CI] Don’t install ragel on circleci jobs
    
    Latest ragel version is broken (https://github.com/adrian-thurston/ragel/issues/56), but we also don’t need to regenerate state machine on CI jobs.

 .circleci/config.yml | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit cde2cf84c0d6515c701296351b9d5a80a41d78c5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 16 23:49:31 2020 -0600

    [use] Minor clean-up of unused categories

 src/hb-ot-shape-complex-use-machine.hh | 34 +++++++++++++++++-----------------
 src/hb-ot-shape-complex-use-machine.rl |  7 -------
 src/hb-ot-shape-complex-use.cc         |  3 +--
 src/hb-ot-shape-complex-use.hh         |  7 -------
 4 files changed, 18 insertions(+), 33 deletions(-)

commit 0792690b73010e24848fe82d5983ef01f38ed1fb
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Fri Oct 16 22:41:12 2020 -0400

    [use] Skip WJ and ZWJ when clustering

 src/gen-use-table.py                               |  13 +-
 src/hb-ot-shape-complex-use-machine.hh             | 580 ++++++++++-----------
 src/hb-ot-shape-complex-use-machine.rl             |   9 +-
 src/hb-ot-shape-complex-use-table.cc               |   8 +-
 src/hb-ot-shape-complex-use.hh                     |   2 -
 .../shaping/data/in-house/tests/use-syllable.tests |   2 +
 6 files changed, 272 insertions(+), 342 deletions(-)

commit 3fcf466b7b77f8eaf281f7a1a4e6ca90b5be54fe
Author: Laurenz <laurmaedje@gmail.com>
Date:   Fri Oct 16 23:03:01 2020 +0200

    [hb-shape-fallback] Use signed int for correction

 src/hb-ot-shape-fallback.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 77e704d1dbfbdb6c54127112814b24358ec52eea
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 02:02:04 2020 -0600

    [buffer] Add assert_unicode()/assert_glyphs() and use internally

 src/hb-buffer-serialize.cc | 13 ++++---------
 src/hb-buffer.cc           | 10 ++++------
 src/hb-buffer.hh           | 10 ++++++++++
 src/hb-shape-plan.cc       |  3 ++-
 4 files changed, 20 insertions(+), 16 deletions(-)

commit 5ef0613909b8223396f2342119d217e2f24aff26
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 01:54:28 2020 -0600

    [buffer] Add ensure_glyphs()/ensure_unicode()
    
    Use in deserialize. To be used more.

 src/hb-buffer-deserialize-json.hh | 1257 +++++++++++++-----------------
 src/hb-buffer-deserialize-json.rl |   21 +-
 src/hb-buffer-deserialize-text.hh | 1531 +++++++++++++++++--------------------
 src/hb-buffer-deserialize-text.rl |   21 +-
 src/hb-buffer.hh                  |   23 +
 5 files changed, 1270 insertions(+), 1583 deletions(-)

commit 84dd65a8740a91e58eaef43c0006ace3a3aa54a7
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Tue Oct 13 20:21:28 2020 +0200

    [test] Remove timeout from test runners
    
    See https://github.com/harfbuzz/harfbuzz/issues/2707#issuecomment-707744079
    
    This wasn’t inconsistent as well, HB_TEST_SUBSET_FUZZER_TIMEOUT defaulted
    to 12 in the test runner, but it was overridden to 50 in meson.build,
    and then meson has its own test timeout.

 .circleci/config.yml                    | 2 +-
 test/fuzzing/meson.build                | 1 -
 test/fuzzing/run-draw-fuzzer-tests.py   | 2 +-
 test/fuzzing/run-shape-fuzzer-tests.py  | 2 +-
 test/fuzzing/run-subset-fuzzer-tests.py | 2 +-
 5 files changed, 4 insertions(+), 5 deletions(-)

commit 3232e6f2a9053e31da67fc7ff293e007e698ef39
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 00:20:17 2020 -0600

    [buffer] Add hb_buffer_has_positions()
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2716

 docs/harfbuzz-sections.txt |  1 +
 src/hb-buffer.cc           | 21 ++++++++++++++++++++-
 src/hb-buffer.h            |  3 +++
 3 files changed, 24 insertions(+), 1 deletion(-)

commit 97a093c52f87dbfb0c800dd09a23436479e69861
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Mon Oct 12 15:32:22 2020 +0200

    [hb-subset] Improve error handling a bit
    
    * Check that output-file option is actually set before trying to open
      it.
    * Print file name and errno when opening the output file fails.
    * Be more resilient when writing output file and use ferror() to check
      for errors.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2711

 util/hb-subset.cc | 36 ++++++++++++++++++------------------
 1 file changed, 18 insertions(+), 18 deletions(-)

commit fa771a7f85d6d07ed64db438c8f07cd6b3f65e3e
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Sun Oct 11 22:11:17 2020 +0200

    [tests] Fix memory leak in test
    
    To make valgrind bot happy.

 test/api/test-buffer.c | 21 +++++++++++----------
 1 file changed, 11 insertions(+), 10 deletions(-)

commit dec52006d939755e38dfc3da6de100f2443d574c
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 10 14:49:55 2020 -0400

    Map BCP 47 tags to all macrolanguages
    
    The general rule is that if a BCP 47 macrolanguage maps to an OpenType
    language system tag, all its individual languages map to it too.
    Previously, a tag like "prs" (Dari) would not map to the language system
    tag ('FAR ') of its macrolanguage ("fa") because "prs" already has its
    own language system tag ('DRI '). That exception has been removed: now
    "prs" maps to 'DRI ' and falls back to 'FAR '.

 src/gen-tag-table.py   |   7 +--
 src/hb-ot-tag-table.hh | 128 ++++++++++++++++++++++++++++++++++++++++++-------
 2 files changed, 112 insertions(+), 23 deletions(-)

commit 1d53268dfe39b6842b5129ce731f67021cb1d844
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 10 14:46:36 2020 -0400

    Fix two-way mapping of "man" and 'MNK '

 src/gen-tag-table.py   | 4 ++--
 src/hb-ot-tag-table.hh | 2 ++
 test/api/test-ot-tag.c | 2 ++
 3 files changed, 6 insertions(+), 2 deletions(-)

commit ab38cf674658fbdde5732171b218fddaaccecbf9
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 10 14:21:20 2020 -0400

    Map hy-arevmda to 'HYE ' instead of HYE0

 src/gen-tag-table.py   | 3 +++
 src/hb-ot-tag-table.hh | 7 +++++++
 2 files changed, 10 insertions(+)

commit 916c5a900708f25b3b6efa7079ae0b9ce701643c
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Oct 10 14:15:16 2020 -0400

    Consistently emit BCP 47 subtag scope suffixes

 src/gen-tag-table.py   |  23 ++++++++---
 src/hb-ot-tag-table.hh | 102 ++++++++++++++++++++++++-------------------------
 2 files changed, 69 insertions(+), 56 deletions(-)
